<?php

/**
 *
 * Default view
 *
 * @version             1.0.0
 * @package             Gavern Framework
 * @copyright			Copyright (C) 2010 - 2011 GavickPro. All rights reserved.
 *               
 */
 
// No direct access.
defined('_JEXEC') or die;

$this->generateColumnsWidth();

$this->addCSSRule('.gkWrap { width: ' . $this->getParam('template_width','1240px') . '!important; }');

$tpl_page_suffix = '';

if($this->page_suffix != '') {
	$tpl_page_suffix = ' class="'.$this->page_suffix.'"';
}

$user = JFactory::getUser();
// getting User ID
$userID = $user->get('id');
// getting params
$option = JRequest::getCmd('option', '');
$view = JRequest::getCmd('view', '');
// defines if register is active
define('GK_REGISTER', ($this->modules('register') ? $userID == 0 : false));
// defines if login is active
define('GK_LOGIN', $this->modules('login'));
// defines if com_users
define('GK_COM_USERS', $option == 'com_users' && ($view == 'login' || $view == 'registration'));

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" 
	  xmlns:og="http://ogp.me/ns#" 
	  xmlns:fb="http://www.facebook.com/2008/fbml" 
	  xml:lang="<?php echo $this->API->language; ?>" lang="<?php echo $this->API->language; ?>">
<head>
	<?php if($this->getParam("chrome_frame_support", '0') == '1') : ?>
	<meta http-equiv="X-UA-Compatible" content="chrome=1"/>
	<?php endif; ?>
	<meta http-equiv="X-UA-Compatible" content="IE=9" />

    <jdoc:include type="head" />
    <?php $this->loadBlock('head'); ?>
</head>
<body<?php echo $tpl_page_suffix; ?>>
	<?php if($this->browser->get('browser') == 'ie6' && $this->getParam('ie6bar', '1') == 1) : ?>
	<div id="gkInfobar"><a href="http://browsehappy.com"><?php echo JText::_('TPL_GK_LANG_IE6_BAR'); ?></a></div>
	<?php endif; ?>
			
	<div id="gkPage" class="gkWrap">
		<div id="gkPageWrap">
	        <div id="gkPageTop" class="clearfix<?php if($this->getParam('top_color', 'dark') == 'dark') echo ' dark'; ?>">
		        <?php $this->loadBlock('logo'); ?>
		        
		        <div id="gkMainMenu">
		  			<?php
		  				$this->menu->loadMenu($this->getParam('menu_name','mainmenu')); 
		  			    $this->menu->genMenu($this->getParam('startlevel', 0), $this->getParam('endlevel',-1));
		  			?>
		  			
		  			<?php if($this->modules('cart')) : ?>
		  			<div id="btnCart"></div>
		  			<?php endif; ?>
		        </div>
	        </div>
	        <?php if($this->generateSubmenu && $this->menu->genMenu($this->getParam('startlevel', 0)+1, $this->getParam('endlevel',-1), true)): ?>
	        <div id="gkSubmenu" class="clear<?php if($this->getParam('top_color', 'dark') == 'dark') echo ' dark'; ?>">
	        	<?php $this->menu->genMenu($this->getParam('startlevel', 0)+1, $this->getParam('endlevel',-1));?>
	        </div>
	        <?php endif; ?>
	  
	  		<?php $this->messages('message-position-1'); ?>
	  
	  		<?php if($this->modules('header1 or header2')) : ?>
	  		<div id="gkHeader" class="clear<?php if($this->getParam('header_spaces', 'nospace') == 'nospace') echo ' nospace'; ?>">
	  			<?php if( $this->modules('header1')) : ?>
	  			<div id="gkHeader1" class="clearfix">
	  				<jdoc:include type="modules" name="header1" style="<?php echo $this->module_styles['header1']; ?>" />
	  			</div>
	  			<?php endif; ?>
	  			
	  			<?php if( $this->modules('header2')) : ?>
	  			<div id="gkHeader2" class="clearfix">
	  				<jdoc:include type="modules" name="header2" style="<?php echo $this->module_styles['header2']; ?>" />
	  			</div>
	  			<?php endif; ?>
	  		</div>
	  		<?php endif; ?>
	  
		    <div id="mainContent" class="clear">	
		    	<?php $this->messages('message-position-2'); ?>
		    	
		    	<?php $this->loadBlock('top'); ?>
		    	
		    	<?php $this->loadBlock('main'); ?>
		    	
		    	<?php $this->loadBlock('user'); ?>
		    </div>
	    </div>
	    
	    <?php if($this->modules('newsletter or social')) : ?>
	    <div id="gkBottomBlock">
	    	<?php if( $this->modules('newsletter')) : ?>
	    	<div id="gkNewsletter" class="clearfix">
	    		<jdoc:include type="modules" name="newsletter" style="<?php echo $this->module_styles['newsletter']; ?>" />
	    	</div>
	    	<?php endif; ?>
	    	
	    	<?php if( $this->modules('social')) : ?>
	    	<div id="gkSocial" class="clearfix">
	    		<jdoc:include type="modules" name="social" style="<?php echo $this->module_styles['social']; ?>" />
	    	</div>
	    	<?php endif; ?>
	    </div>
	    <?php endif; ?>
    </div>
    
    <?php if(($this->modules('bottom1 + bottom2 + bottom3 + bottom4 + bottom5 + bottom6')) || ($this->modules('bottom7 + bottom8 + bottom9 + bottom10 + bottom11 + bottom12'))) : ?>
    <div id="gkBottomWrap" class="gkWrap clear">
        <?php $this->loadBlock('bottom'); ?>
    </div>
    <?php endif; ?>
    
    <div id="gkFooter" class="gkWrap">
    	<?php $this->loadBlock('footer'); ?> 
    </div>
    
    <?php if(GK_LOGIN && !GK_COM_USERS) : ?>	
    <div id="gkPopupLogin">	
    	<div class="gkPopupWrap">
    	     <?php $this->loadBlock('tools/login'); ?>
    	</div>
    	</div>
    <?php endif; ?>
    
    <?php if(GK_REGISTER && !GK_COM_USERS) : ?>
    <div id="gkPopupRegister">	
    	<div class="gkPopupWrap">
    		<?php $this->loadBlock('tools/register'); ?>
    	</div>
    </div>
    <?php endif; ?>
    
    <?php if($this->modules('cart')) : ?>	
    <div id="gkPopupCart">	
    	<div class="gkPopupWrap">
    	     <?php $this->loadBlock('tools/cart'); ?>
    	</div>
    </div>
    <?php endif; ?>
    
    <?php if(((GK_REGISTER || GK_LOGIN) && !GK_COM_USERS) || $this->modules('cart')) : ?>
    <div id="gkPopupOverlay"></div>
    <?php endif; ?>
   
	<jdoc:include type="modules" name="debug" />
</body>
</html>