<?php
/**
 * @copyright Copyright (C) 2010 redCOMPONENT.com. All rights reserved.
 * @license GNU/GPL, see license.txt or http://www.gnu.org/copyleft/gpl.html
 * Developed by email@recomponent.com - redCOMPONENT.com
 *
 * redSHOP can be downloaded from www.redcomponent.com
 * redSHOP is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * You should have received a copy of the GNU General Public License
 * along with redSHOP; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

// no direct access


defined ( '_JEXEC' ) or die ( 'Restricted access' );
require_once (JPATH_SITE . DS . 'components' . DS . 'com_redshop' . DS . 'helpers' . DS . 'helper.php');
require_once (JPATH_SITE . DS . 'components' . DS . 'com_redshop' . DS . 'helpers' . DS . 'cart.php');
require_once (JPATH_SITE . DS . 'components' . DS . 'com_redshop' . DS . 'helpers' . DS . 'product.php');
require_once (JPATH_SITE.DS.'components'.DS.'com_redshop'.DS.'helpers'.DS.'extra_field.php' );
require_once (JPATH_SITE . DS . 'components' . DS . 'com_redshop' . DS . 'helpers' . DS . 'tcpdf' . DS . 'config' . DS . 'lang' . DS . 'eng.php');
require_once (JPATH_SITE . DS . 'components' . DS . 'com_redshop' . DS . 'helpers' . DS . 'tcpdf' . DS . 'tcpdf.php');

require_once (JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_redshop' . DS . 'helpers' . DS . 'extra_field.php');
require_once (JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_redshop' . DS . 'helpers' . DS . 'configuration.php');
require_once (JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_redshop' . DS . 'helpers' . DS . 'order.php');
require_once (JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_redshop' . DS . 'helpers' . DS . 'quotation.php');

class redshopMail {

	var $_table_prefix = null;
	var $db = null;
	var $_carthelper = null;
	var $_redhelper = null;

	function __construct() {

		global $mainframe, $context;
		$db = JFactory::getDbo ();
		$this->_table_prefix = '#__' . TABLE_PREFIX . '_';
		$this->_db = $db;
		$this->_carthelper = new rsCarthelper();
		$this->_redhelper = new redhelper();
		$this->_order_functions = new order_functions();

	}
	/**
	 * Method to get mail section
	 *
	 * @access public
	 * @return array
	 */

	function getMailtemplate($tid = 0, $section = "", $extracond = "")
	{
		$str = '';
		if ($tid != 0)
		{
			$str .= ' AND mail_id = ' . $tid;
		}
		if ($section != "")
		{
			$str .= ' AND mail_section = "' . $section . '" ';
		}
		if ($extracond != "")
		{
			$str .= 'AND '.$extracond.' ';
		}
		$query = 'SELECT * FROM '.$this->_table_prefix.'mail '
				.'WHERE published=1 '
				.$str;
		$this->_db->setQuery ( $query );
		$list = $this->_db->loadObjectlist ();
		return $list;

	}
	function sendOrderMail($order_id, $reddesign = 0)
	{
		$redconfig = new Redconfiguration ();
		$producthelper = new producthelper ();
		$extra_field = new extra_field ();

		$config = &JFactory::getConfig ();
		// Set the e-mail parameters

		$from = $config->getValue ( 'mailfrom' );
		$fromname = $config->getValue ( 'fromname' );
		$user = & JFactory::getUser ();
		if (USE_AS_CATALOG)
		{
			$mailinfo = $this->getMailtemplate ( 0, "catalogue_order" );
		} else
		{
			$mailinfo = $this->getMailtemplate ( 0, "order" );
		}

		if (count ( $mailinfo ) > 0)
		{
			$message = $mailinfo [0]->mail_body;
			$subject = $mailinfo [0]->mail_subject;
		}
		else
		{
			return false;
		}
		
		$cart = '';
        $row = $this->_order_functions->getOrderDetails ( $order_id );

		$orderpayment = $this->_order_functions->getOrderPaymentDetail ( $order_id );
		$paymentmethod = $this->_order_functions->getPaymentMethodInfo ( $orderpayment [0]->payment_method_class );

		$paymentmethod = $paymentmethod [0];

		# by Gunjan
		# it is necessory to take billing info from order user info table
		# "Order mail output should reflect the checkout process"

		$message 		 = $this->_carthelper->replaceOrderTemplate($row,$message);

		$rowitem 		 = $this->_order_functions->getOrderItemDetail ( $order_id );
		$billingaddresses=$this->_order_functions->getBillingAddress ( $user->id );

		$manufacturer_email 	= array ();
		$supplier_email 		= array ();
		$reddesign_msg 			= array ();
		$reddesign_attachment 	= array ();
		$cartArr 				= array();

		$cart_mdata 			= '';

		for($i = 0; $i < count ( $rowitem ); $i ++)
		{

			$product = $producthelper->getProductById ( $rowitem[$i]->product_id );
			$manufacturerData = $producthelper->getSection("manufacturer",$product->manufacturer_id);
			if(count($manufacturerData)>0)
			{
				if($manufacturerData->manufacturer_email!='')
				{
					$manufacturer_email[$i] = $manufacturerData->manufacturer_email;
				}
			}
			$supplierData = $producthelper->getSection("supplier",$product->supplier_id);
			if(count($supplierData)>0)
			{
				if($supplierData->supplier_email!='')
				{
					$supplier_email[$i] = $supplierData->supplier_email;
				}
			}

		}

		$arr_discount_type 	= array ();
		$arr_discount 		= explode ( '@', $row->discount_type );
		$discount_type 		= '';
		for($d = 0; $d < count ( $arr_discount ); $d ++)
		{
			if ($arr_discount [$d])
			{
				$arr_discount_type = explode ( ':', $arr_discount [$d] );
				if ($arr_discount_type [0] == 'c')
					$discount_type .= JText::_('COM_REDSHOP_COUPON_CODE' ) . ' : ' . $arr_discount_type [1] . '<br>';
				if ($arr_discount_type [0] == 'v')
					$discount_type .= JText::_('COM_REDSHOP_VOUCHER_CODE' ) . ' : ' . $arr_discount_type [1] . '<br>';
			}
		}
		if (! $discount_type)
		{
			$discount_type = JText::_('COM_REDSHOP_NO_DISCOUNT_AVAILABLE' );
		}

		$search [] = "{discount_type}";
		$replace [] = $discount_type;
		$split_amount = 0; //($cart['total']+JRequest::getVar('order_ship')) / 2;

		$issplitdisplay 	= '';
		$issplitdisplay2 	= '';

		if ($row->split_payment)
		{
			$issplitdisplay = "<br/>" . JText::_('COM_REDSHOP_RECEIPT_PARTIALLY_PAID_AMOUNT' ) . ": " . $producthelper->getProductFormattedPrice ( $split_amount );
			$issplitdisplay2 = "<br/>" . JText::_('COM_REDSHOP_REMAINING_PARTIALLY_AMOUNT' ) . ": " . $producthelper->getProductFormattedPrice ( $split_amount );
		}
		$orderdetailurl = JURI::root () . 'index.php?option=com_redshop&view=order_detail&oid=' . $order_id . '&encr=' . $row->encr_key;
		$search  [] 	= "{order_detail_link}";
		$replace [] 	= "<a href='" . $orderdetailurl . "'>" . JText::_ ( "ORDER_MAIL" ) . "</a>";
		$txtextra_info = '';
		if ($paymentmethod->element == "rs_payment_banktransfer" || $paymentmethod->element == "rs_payment_banktransfer_discount" || $paymentmethod->element == "rs_payment_banktransfer2" || $paymentmethod->element == "rs_payment_banktransfer3" || $paymentmethod->element == "rs_payment_banktransfer4" || $paymentmethod->element == "rs_payment_banktransfer5")
		{
			$paymentpath=JPATH_SITE.DS.'plugins'.DS.'redshop_payment'.DS.$paymentmethod->element.'.xml';
			$paymentparams = new JRegistry( $paymentmethod->params );
			$txtextra_info = $paymentparams->get('txtextra_info','');
		}
		$search  [] 	= "{payment_extrainfo}";
		$replace [] 	= $txtextra_info;

		$billingaddresses 	= $this->_order_functions->getOrderBillingUserInfo($order_id);
		$message = str_replace ( $search, $replace, $message );
		$message = $this->imginmail ( $message );
		$thirdpartyemail=$billingaddresses->thirdparty_email;
		$email = $user->email;

		if ($email == "")
		{
			$email = $billingaddresses->user_email;
		}
		$search [] = "{order_id}";
		$replace [] = $row->order_id;
		$search [] = "{order_number}";
		$replace [] = $row->order_number;
		$search_sub [] = "{order_id}";
		$replace_sub [] = $row->order_id;
		$search_sub [] = "{order_number}";
		$replace_sub [] = $row->order_number;
		$search_sub []= "{shopname}";
		$replace_sub []= SHOP_NAME;
		$search_sub[] = "{order_date}";
		$replace_sub[] = $redconfig->convertDateFormat($row->cdate);
		//$body = $message;
		$subject = str_replace ( $search_sub, $replace_sub, $subject );
		if ($reddesign)
		{
			$mailinfo 	= $this->getMailtemplate ( 0, "redDesign_mail" );
			$message 	= $mailinfo [0]->mail_body;
			$subject 	= html_entity_decode ( $mailinfo [0]->mail_subject, ENT_QUOTES );
			$message 	= $this->_carthelper->replaceredDesignmail($order_id,$message,$reddesign_attachment);

			$subject    = str_replace ( "{order_id}", $order_id, $subject );
			//	get all super administrator
			$rowsadminlist = $this->_redhelper->getselectedAdminlist ();
//			$message = $loopmessage_start . implode ( "<br>", $reddesign_msg ) . $loopmessage_end;
			for($ri = 0; $ri < count ( $rowsadminlist ); $ri ++)
			{
				if ($rowsadminlist [$ri]->email != "")
				{
					JUtility::sendMail ( $from, $fromname, $rowsadminlist [$ri]->email, $subject, $message, 1, '', '', $reddesign_attachment );
				}
			}
		}
		// Send the e-mail

		if ($email != "")
		{
			$bcc = (trim ( ADMINISTRATOR_EMAIL ) != '') ? explode(",",trim(ADMINISTRATOR_EMAIL)) : NULL;
			$fullname = $billingaddresses->firstname." ".$billingaddresses->lastname;
			if($billingaddresses->is_company==1 && $billingaddresses->company_name!="")
			{
				$fullname=$billingaddresses->company_name;
			}
			$subject = str_replace ( "{fullname}", $fullname, $subject );
			$subject = str_replace ( "{firstname}", $billingaddresses->firstname, $subject );
			$subject = str_replace ( "{lastname}", $billingaddresses->lastname, $subject );
			$message = str_replace ( "{fullname}", $fullname, $message );
			$message = str_replace ( "{firstname}", $billingaddresses->firstname, $message );
			$message = str_replace ( "{lastname}", $billingaddresses->lastname, $message );
			$body 	 = $message;

			if($thirdpartyemail!='')
			{
				if (! JUtility::sendMail ( $from, $fromname, $thirdpartyemail, $subject, $body, 1, NULL, $bcc ))
				{
					$this->setError ( JText::_('COM_REDSHOP_ERROR_SENDING_CONFIRMATION_MAIL' ));
				}
			}

			if (! JUtility::sendMail ( $from, $fromname, $email, $subject, $body, 1, NULL, $bcc ))
			{
				$this->setError ( JText::_('COM_REDSHOP_ERROR_SENDING_CONFIRMATION_MAIL' ));
			}

			// download product send mail
			if ($row->order_status == "C")
			{
				$this->_order_functions->SendDownload ( $order_id );
			}
		}

		if (MANUFACTURER_MAIL_ENABLE)
		{
			sort ( $manufacturer_email );
			for($man = 0; $man < count ( $manufacturer_email ); $man ++)
			{
				if (! JUtility::sendMail ( $from, $fromname, $manufacturer_email [$man], $subject, $body, 1 ))
				{
					$this->setError (JText::_('COM_REDSHOP_ERROR_SENDING_CONFIRMATION_MAIL' ));
				}
			}
		}

	    if(SUPPLIER_MAIL_ENABLE)
	    {
			sort ( $supplier_email );
			for($sup = 0; $sup < count ( $supplier_email ); $sup++)
			{
				if (! JUtility::sendMail ( $from, $fromname, $supplier_email [$sup], $subject, $body, 1 ))
				{
					$this->setError (JText::_('COM_REDSHOP_ERROR_SENDING_CONFIRMATION_MAIL' ));
				}
			}
	    }
		// INVOICE MAIL SEND
		if (INVOICE_MAIL_ENABLE)
		{
			$this->sendInvoiceMail($order_id);
		}
		return true;
	}

	function sendOrderSpecialDiscountMail($order_id)
	{
		$redconfig 		= new Redconfiguration ();
		$producthelper 	= new producthelper ();
		$extra_field 	= new extra_field ();
		$config 		= &JFactory::getConfig ();
		$mailinfo 		= $this->getMailtemplate ( 0, "order_special_discount" );
		if (count ( $mailinfo ) > 0)
		{
			$message = $mailinfo [0]->mail_body;
			$subject = $mailinfo [0]->mail_subject;
		}
		else
		{
			return false;
		}
		
		$cart 			= '';

		$manufacturer_email = array ();

		$row 			= $this->_order_functions->getOrderDetails ( $order_id );
		$orderpayment 	= $this->_order_functions->getOrderPaymentDetail ( $order_id );
		$paymentmethod 	= $this->_order_functions->getPaymentMethodInfo ( $orderpayment [0]->payment_method_class );
		$paymentmethod 	= $paymentmethod [0];
		$partialpayment = $this->_order_functions->getOrderPartialPayment ( $order_id );
		$message 		= $this->_carthelper->replaceOrderTemplate($row,$message);

		// set order paymethod name

		$search  [] = "{shopname}";
		$replace [] = SHOP_NAME;
		$search  [] = "{payment_lbl}";
		$replace [] = JText::_('COM_REDSHOP_PAYMENT_METHOD' );
		$search  [] = "{payment_method}";
		$replace [] = ""; //$paymentmethod->payment_method_name;
		$search  [] = "{special_discount}";
		$replace [] = $row->special_discount.'%';
		$search  [] = "{special_discount_amount}";
		$replace [] = $producthelper->getProductFormattedPrice($row->special_discount_amount);
		$search  [] = "{special_discount_lbl}";
		$replace [] = JText::_('COM_REDSHOP_SPECIAL_DISCOUNT');

		$orderdetailurl = JURI::root () . 'index.php?option=com_redshop&view=order_detail&oid=' . $order_id . '&encr=' . $row->encr_key;
		$search [] = "{order_detail_link}";
		$replace [] = "<a href='" . $orderdetailurl . "'>" . JText::_ ( "ORDER_MAIL" ) . "</a>";

		if ($paymentmethod->element == "rs_payment_banktransfer" || $paymentmethod->element == "rs_payment_banktransfer_discount" || $paymentmethod->element == "rs_payment_banktransfer2" || $paymentmethod->element == "rs_payment_banktransfer3" || $paymentmethod->element == "rs_payment_banktransfer4" || $paymentmethod->element == "rs_payment_banktransfer5")
		{
			$paymentpath=JPATH_SITE.DS.'plugins'.DS.'redshop_payment'.DS.$paymentmethod->element.'.xml';
			$paymentparams = new JRegistry( $paymentmethod->params );
			$txtextra_info = $paymentparams->get('txtextra_info','');

			$search  [] 	= "{payment_extrainfo}";
			$replace [] 	= $txtextra_info;
		}
		$message = str_replace ( $search, $replace, $message );
		$message = $this->imginmail ( $message );

		$email 		= $billingaddresses->user_email;
		$from 		= $config->getValue ( 'mailfrom' );
		$fromname 	= $config->getValue ( 'fromname' );
		$body 		= $message;
		$subject 	= str_replace ( $search, $replace, $subject );

		if ($email != "")
		{
			$bcc = NULL;
			if (trim ( ADMINISTRATOR_EMAIL ) != '')
				$bcc = explode(",",trim(ADMINISTRATOR_EMAIL));
			if(SPECIAL_DISCOUNT_MAIL_SEND=='1')
			{
				if (! JUtility::sendMail ( $from, $fromname, $email, $subject, $body, 1, NULL, $bcc ))
				{
					$this->setError (JText::_('COM_REDSHOP_ERROR_SENDING_CONFIRMATION_MAIL' ));
				}
			}
		}

		if (MANUFACTURER_MAIL_ENABLE)
		{
			sort ( $manufacturer_email );
			for($man = 0; $man < count ( $manufacturer_email ); $man ++)
			{
				if (! JUtility::sendMail ( $from, $fromname, $manufacturer_email [$man], $subject, $body, 1 ))
				{
					$this->setError (JText::_('COM_REDSHOP_ERROR_SENDING_CONFIRMATION_MAIL' ));
				}
			}
		}
		return true;
	}

	function sendInvoiceMail($order_id)
	{
		$redconfig 		= new Redconfiguration ();
		$producthelper 	= new producthelper ();
		$extra_field 	= new extra_field ();
		$config 		= &JFactory::getConfig ();
		$message 		= "";
		$subject 		= "";
		$cart 			= '';

		$arr_discount_type = array ();

		$mailinfo = $this->getMailtemplate ( 0, "invoice_mail" );
		if (count ( $mailinfo ) > 0)
		{
			$message = $mailinfo [0]->mail_body;
			$subject = $mailinfo [0]->mail_subject;
		}
		else
		{
			return false;
		}

		$row 			= $this->_order_functions->getOrderDetails ( $order_id );
		$barcode_code 	= $row->barcode;
		$arr_discount 	= explode ( '@', $row->discount_type );
		$discount_type 	= '';

		for($d = 0; $d < count ( $arr_discount ); $d ++)
		{
			if ($arr_discount [$d])
			{
				$arr_discount_type = explode ( ':', $arr_discount [$d] );
				if ($arr_discount_type [0] == 'c')
					$discount_type .= JText::_('COM_REDSHOP_COUPON_CODE' ) . ' : ' . $arr_discount_type [1] . '<br>';

				if ($arr_discount_type [0] == 'v')
					$discount_type .= JText::_('COM_REDSHOP_VOUCHER_CODE' ) . ' : ' . $arr_discount_type [1] . '<br>';
			}
		}

		if (! $discount_type)
		{
			$discount_type = JText::_('COM_REDSHOP_NO_DISCOUNT_AVAILABLE' );
		}

		$search [] = "{discount_type}";
		$replace [] = $discount_type;

		// set order paymethod name
		$search_sub []="{order_id}";
		$replace_sub []=$row->order_id;
		$search_sub []="{order_number}";
		$replace_sub []=$row->order_number;
		$search_sub []= "{shopname}";
		$replace_sub []= SHOP_NAME;

		$message = str_replace ( $search, $replace, $message );
		$message = $this->imginmail ( $message );
		$user = & JFactory::getUser ();
		//$billingaddresses=$this->_order_functions->getBillingAddress ( $user->id );
		$billingaddresses 	= $this->_order_functions->getOrderBillingUserInfo($order_id);
		$email 	 = $billingaddresses->user_email;
		$userfullname = $billingaddresses->firstname." ".$billingaddresses->lastname;
		$search_sub[] = "{fullname}";
		$replace_sub[] = $userfullname;
		$search_sub[] = "{order_date}";
		$replace_sub[] = $redconfig->convertDateFormat($row->cdate);
		$subject =str_replace ( $search_sub, $replace_sub, $subject);

		// Set the e-mail parameters
		$from 		= $config->getValue ( 'mailfrom' );
		$fromname 	= $config->getValue ( 'fromname' );
		$message	= $this->_carthelper->replaceOrderTemplate($row,$message);
		$body = $message;
		$body1 = $message;
        $img_url1 = REDSHOP_FRONT_IMAGES_ABSPATH."barcode/".$barcode_code.".png";
		$img_url = REDSHOP_FRONT_IMAGES_RELPATH."barcode/".$barcode_code.".png";

// for pdf
        if( function_exists( "curl_init" ))
        {
	         $bar_codeIMG = '<img src="'.$img_url.'" alt="Barcode"  border="0" />';
    	     $body = str_replace ( "{barcode}", $bar_codeIMG, $body );
// for mail
	         $bar_codeIMG1 = '<img src="'.$img_url1.'" alt="Barcode"  border="0" />';
    	     $body1 = str_replace ( "{barcode}", $bar_codeIMG1, $body1 );
        }
        $message	= $this->_carthelper->replaceOrderTemplate($row,$message);
		ob_clean ();

		echo "<div id='redshopcomponent' class='redshop'>";

		$pdfObj = new TCPDF ( PDF_PAGE_ORIENTATION, PDF_UNIT, 'A5', true, 'UTF-8', false );
		$pdfObj->SetTitle ( JText::_('COM_REDSHOP_INVOICE' ) . $row->order_id );
		$pdfObj->SetAuthor ( 'redSHOP' );
		$pdfObj->SetCreator ( 'redSHOP' );
		$pdfObj->SetMargins ( 15, 15, 15 );
		$font = 'times';
        $pdfObj->setImageScale(PDF_IMAGE_SCALE_RATIO);
		$pdfObj->setHeaderFont ( array ($font, '', 10 ) );
		$pdfObj->SetFont ( $font, "", 12 );
		$pdfObj->AddPage ();
		$pdfObj->WriteHTML ( $body , true, false, true, false, '');

		$invoice_pdfName = $row->order_id;

		$pdfObj->Output ( JPATH_SITE . DS . 'components' . DS . 'com_redshop' . DS . 'assets' . DS . 'document' . DS . 'invoice' . DS . $invoice_pdfName . ".pdf", "F" );
		$invoice_attachment = JPATH_SITE . DS . 'components' . DS . 'com_redshop' . DS . 'assets' . DS . 'document' . DS . 'invoice' . DS . $invoice_pdfName . ".pdf";
		if ((INVOICE_MAIL_SEND_OPTION == 2 || INVOICE_MAIL_SEND_OPTION == 3) && $email != "")
		{
			if (! JUtility::sendMail ( $from, $fromname, $email, $subject, $body1, 1, NULL, NULL, $invoice_attachment ))
			{
				$this->setError ( JText::_('COM_REDSHOP_ERROR_SENDING_CONFIRMATION_MAIL' ));
				return false;
			}
		}

		if ((INVOICE_MAIL_SEND_OPTION == 1 || INVOICE_MAIL_SEND_OPTION == 3) && ADMINISTRATOR_EMAIL != '')
		{
			$sendto = explode(",",trim(ADMINISTRATOR_EMAIL));
			if (! JUtility::sendMail ( $from, $fromname, $sendto, $subject, $body1, 1, NULL, NULL, $invoice_attachment ))
			{
				$this->setError ( JText::_('COM_REDSHOP_ERROR_SENDING_CONFIRMATION_MAIL' ));
				return false;
			}
		}
		return true;
	}

	function sendRegistrationMail(&$data)
	{
		global $mainframe;

		$acl = & JFactory::getACL ();
		$db = & JFactory::getDBO ();
		$me = & JFactory::getUser ();

		$mainpassword = JRequest::getVar ( 'password1', '', 'post', 'string', JREQUEST_ALLOWRAW );

		$MailFrom = $mainframe->getCfg ( 'mailfrom' );
		$FromName = $mainframe->getCfg ( 'fromname' );
		$SiteName = $mainframe->getCfg ( 'sitename' );

		/*
	 	 * Time for the email magic so get ready to sprinkle the magic dust...
	 	 */
		$adminEmail = $me->get ( 'email' );
		$adminName = $me->get ( 'name' );
		$maildata = "";
		$mailsubject = "";
		$mailtemplate = $this->getMailtemplate ( 0, "register" );
		if (count ( $mailtemplate ) > 0)
		{
			$maildata = $mailtemplate[0]->mail_body;//html_entity_decode ( $mailtemplate[0]->mail_body, ENT_QUOTES );
			$mailsubject = $mailtemplate[0]->mail_subject;//html_entity_decode ( $mailtemplate[0]->mail_subject, ENT_QUOTES );
		}
		else
		{
			return false;
		}
		$search = array ();
		$replace = array ();
		$search [] = "{shopname}";
		$search [] = "{firstname}";
		$search [] = "{lastname}";
		$search [] = "{fullname}";
		$search [] = "{name}";
		$search [] = "{username}";
		$search [] = "{password}";
		$search [] = "{email}";

		$replace [] = SHOP_NAME;
		$replace [] = $data ['firstname'];
		$replace [] = $data ['lastname'];
		$replace [] = $data ['firstname']." ".$data ['lastname'];
		$replace [] = $data ['name'];
		$replace [] = $data ['username'];
		$replace [] = $mainpassword;
        $replace [] = $data['email'];



		$mailbody = str_replace ( $search, $replace, $maildata );
		$mailsubject = str_replace ( $search, $replace, $mailsubject );

		if ($MailFrom != '' && $FromName != '')
		{
			$adminName = $FromName;
			$adminEmail = $MailFrom;
		}
		$bcc = NULL;


		if($mailbody && $data['email'] != "")
		{

			if(trim(ADMINISTRATOR_EMAIL)!='')
			{
				$bcc = explode(",",trim(ADMINISTRATOR_EMAIL));
			}
			JUtility::sendMail ( $MailFrom, $FromName, $data['email'], $mailsubject, $mailbody, 1, NULL, $bcc );
		}
		//tax exempt waiting approval mail
		if(USE_TAX_EXEMPT && $post['tax_exempt']==1)
		{
			$this->sendTaxExemptMail("tax_exempt_waiting_approval_mail", $post, $bcc);
		}
		//tax exempt waiting approval mail
		return true;
	}

	function sendTaxExemptMail($section, $userinfo=array(), $email = "")
	{
		if(USE_TAX_EXEMPT)
		{
			global $mainframe;

			$MailFrom = $mainframe->getCfg ( 'mailfrom' );
			$FromName = $mainframe->getCfg ( 'fromname' );

			$maildata = $section;
			$mailsubject = $section;
			$mailtemplate = $this->getMailtemplate ( 0, $section );
			if(count($mailtemplate) > 0)
			{
				$maildata = html_entity_decode ( $mailtemplate[0]->mail_body, ENT_QUOTES );
				$mailsubject = html_entity_decode ( $mailtemplate[0]->mail_subject, ENT_QUOTES );
			}
			$search = array ();
			$replace = array ();

			$search [] = "{shopname}";
			$search [] = "{name}";
			$search [] = "{company_name}";
			$search [] = "{address}";
			$search [] = "{city}";
			$search [] = "{zipcode}";
			$search [] = "{country}";
			$search [] = "{phone}";

			$replace [] = SHOP_NAME;
			$replace [] = $userinfo['firstname'].' '.$userinfo['lastname'];
			if ($userinfo['is_company']==1)
			{

				$replace [] = $userinfo['company_name'];
			}
			else
			{

				$replace [] = "";
			}
			$replace [] = $userinfo['address'];
			$replace [] = $userinfo['city'];
			$replace [] = $userinfo['zipcode'];
			$replace [] = $this->_order_functions->getCountryName($userinfo['country_code']);
			$replace [] = $userinfo['phone'];

			$maildata = str_replace ( $search, $replace, $maildata );
//			$mailsubject = str_replace ( $search, $replace, $mailsubject );

			if($email != "")
			{
				JUtility::sendMail ( $MailFrom, $FromName, $email, $mailsubject, $maildata, 1 );
			}
		}
		return true;
	}

	function sendSubscriptionRenewalMail($data = array())
	{

		global $mainframe;

		$producthelper = new producthelper ();

		$redconfig = new Redconfiguration ();

		$MailFrom = $mainframe->getCfg ( 'mailfrom' );

		$FromName = $mainframe->getCfg ( 'fromname' );

		$SiteName = $mainframe->getCfg ( 'sitename' );

		$user_email = "";

		$firstname = "";

		$lastname = "";

		$maildata = "";

		$mailsubject = "";

		$mailtemplate = $this->getMailtemplate ( 0, "subscription_renewal_mail" );

		if (count ( $mailtemplate ) > 0)
		{
			$mailtemplate = $mailtemplate [0];
			$maildata = $mailtemplate->mail_body;
			$mailsubject = $mailtemplate->mail_subject;
		}
		else
		{
			return false;
		}

		$userdata = $this->_order_functions->getBillingAddress ( $data->user_id );
		if (count ( $userdata ) > 0)
		{
			$user_email = $userdata->user_email;
			$firstname = $userdata->firstname;
			$lastname = $userdata->lastname;
		}

		$product = $producthelper->getProductById ( $data->product_id );
		$productSubscription = $producthelper->getProductSubscriptionDetail ( $data->product_id, $data->subscription_id );

		$search = array ();

		$replace = array ();

		$search [] = "{shopname}";

		$search [] = "{firstname}";

		$search [] = "{lastname}";

		$search [] = "{product_name}";

		$search [] = "{subsciption_enddate}";

		$search [] = "{subscription_period}";

		$search [] = "{subscription_price}";

		$search [] = "{product_link}";

		$replace [] = SHOP_NAME;

		$replace [] = $firstname;

		$replace [] = $lastname;

		$replace [] = $product->product_name;

		$replace [] = $redconfig->convertDateFormat ( $data->end_date );

		$replace [] = $productSubscription->subscription_period . " " . $productSubscription->period_type;

		$replace [] = $producthelper->getProductFormattedPrice ( $productSubscription->subscription_price );

		$producturl = JURI::root () . 'index.php?option=com_redshop&view=product&pid=' . $data->product_id;

		$replace [] = "<a href='" . $producturl . "'>" . $product->product_name . "</a>";

		$maildata = str_replace ( $search, $replace, $maildata );

		$mailsubject = str_replace ( $search, $replace, $mailsubject );

		if ($user_email != "")
		{
			JUtility::sendMail ( $MailFrom, $FromName, $user_email, $mailsubject, $maildata, 1 );
		}

		return true;
	}

	function imginmail($message) {

		$uri = &JFactory::getURI ();

		$url = $uri->root ();

		$data1 = $data = $message;

		preg_match_all ( "/\< *[img][^\>]*[.]*\>/i", $data, $matches );

		foreach ( $matches [0] as $match ) {

			preg_match_all ( "/(src|height|width)*= *[\"\']{0,1}([^\"\'\ \>]*)/i", $match, $m );

			$images [] = array_combine ( $m [1], $m [2] );

			$imagescur = array_combine ( $m [1], $m [2] );

			$imagescurarray [] = $imagescur ['src'];

		}

		$imagescurarray = @array_unique ( $imagescurarray );

		if ($imagescurarray) {

			foreach ( $imagescurarray as $change ) {

				if (strpos ( $change, 'http' ) === false) {

					$data1 = str_replace ( $change, $url . $change, $data1 );

				}

			}

		}

		return $data1;

	}

	function sendQuotationMail($quotation_id, $status = 0)
	{

		$uri = & JURI::getInstance ();

		$url = $uri->root ();

		$redconfig = new Redconfiguration ();

		$producthelper = new producthelper ();

		$extra_field = new extra_field ();

		$quotationHelper = new quotationHelper ();

		$config = &JFactory::getConfig ();

		$mailinfo = $this->getMailtemplate ( 0, "quotation_mail" );
		if (count ( $mailinfo ) > 0)
		{
			$message = $mailinfo [0]->mail_body;
			$subject = $mailinfo [0]->mail_subject;
		}
		else
		{
			return false;
		}

		$template_start = "";

		$template_end = "";

		$template_middle = "";

		$cart = '';

		$template_sdata = explode ( '{product_loop_start}', $message );

		$extraField = new extraField();
		$fieldArray = $extraField->getSectionFieldList(17,0,0);

		if (count ( $template_sdata ) > 0)
		{

			$template_start = $template_sdata [0];

			if (count ( $template_sdata ) > 1)
			{

				$template_edata = explode ( '{product_loop_end}', $template_sdata [1] );

				if (count ( $template_edata ) > 1)
				{
					$template_end = $template_edata [1];
				}

				if (count ( $template_edata ) > 0)
				{
					$template_middle = $template_edata [0];
				}

			}

		}

		$row = $quotationHelper->getQuotationDetail ( $quotation_id );

		if (count ( $row ) <= 0)
		{
			return false;
		}

		$rowitem = $quotationHelper->getQuotationProduct ( $quotation_id );

		for($i=0;$i<count($rowitem);$i++)
		{
			$product_id = $rowitem[$i]->product_id;
			$product = $producthelper->getProductById ( $product_id );
			$product_name = "<div class='product_name'>".$rowitem[$i]->product_name."</div>";
			$product_total_price = "<div class='product_price'>".$producthelper->getProductFormattedPrice( ($rowitem[$i]->product_price * $rowitem[$i]->product_quantity)  )."</div>";
			$product_price = "<div class='product_price'>".$producthelper->getProductFormattedPrice( $rowitem[$i]->product_price )."</div>";
			$product_quantity = '<div class="update_cart">'.$rowitem[$i]->product_quantity.'</div>';

			$cart_mdata = $template_middle;
			$wrapper_name = "";
			if($rowitem[$i]->product_wrapperid)
			{
				$wrapper = $producthelper->getWrapper($product_id,$rowitem[$i]->product_wrapperid);
				if(count($wrapper)>0)
	   	  		{
	   	  			$wrapper_name = $wrapper[0]->wrapper_name;
	   	  		}
				$wrapper_name = JText::_('COM_REDSHOP_WRAPPER').": ".$wrapper_name;
			}

			$product_image_path = "";
			if($product->product_full_image)
			{
				if(is_file(REDSHOP_FRONT_IMAGES_RELPATH."product/".$product->product_full_image))
				{
					$product_image_path = $url."/components/com_redshop/helpers/thumb.php?filename=product/".$product->product_full_image;
				}
				else
				{
					if(is_file(REDSHOP_FRONT_IMAGES_RELPATH."product/".PRODUCT_DEFAULT_IMAGE))
					{
						$product_image_path = $url."/components/com_redshop/helpers/thumb.php?filename=product/".PRODUCT_DEFAULT_IMAGE;
					}
				}
			} else {
				if(is_file(REDSHOP_FRONT_IMAGES_RELPATH."product/".PRODUCT_DEFAULT_IMAGE))
				{
					$product_image_path = $url."/components/com_redshop/helpers/thumb.php?filename=product/".PRODUCT_DEFAULT_IMAGE;
				}
			}
			if($product_image_path)
			{
				$product_image ="<div  class='product_image'><img src='".$product_image_path."&newxsize=".CART_THUMB_WIDTH."&newysize=".CART_THUMB_HEIGHT."&swap=".USE_IMAGE_SIZE_SWAPPING."'></div>";
			} else {
				$product_image ="<div  class='product_image'></div>";
			}

			$cart_mdata = str_replace ( "{product_name}", $product_name, $cart_mdata );
			$cart_mdata = str_replace ( "{product_s_desc}", $product->product_s_desc, $cart_mdata );
			$cart_mdata = str_replace ( "{product_thumb_image}", $product_image, $cart_mdata );

			$product_note = "<div class='product_note'>".$wrapper_name."</div>";
			$cart_mdata = str_replace ( "{product_note}", $product_note, $cart_mdata );
			$product_userfields = $quotationHelper->displayQuotationUserfield($rowitem[$i]->quotation_item_id,12);

			$cart_mdata = str_replace ( "{product_userfields}", $product_userfields, $cart_mdata );

			$cart_mdata = str_replace ( "{product_number_lbl}", JText::_('COM_REDSHOP_PRODUCT_NUMBER'), $cart_mdata );

			$cart_mdata = str_replace ( "{product_number}", $product->product_number, $cart_mdata );

			$cart_mdata = str_replace ( "{product_attribute}", $producthelper->makeAttributeQuotation($rowitem[$i]->quotation_item_id,0,$rowitem[$i]->product_id,$row->quotation_status), $cart_mdata );

			$cart_mdata = str_replace ( "{product_accessory}", $producthelper->makeAccessoryQuotation($rowitem[$i]->quotation_item_id,$row->quotation_status), $cart_mdata );

			// ProductFinderDatepicker Extra Field Start


			$cart_mdata = $producthelper->getProductFinderDatepickerValue($cart_mdata,$product_id,$fieldArray);

			// ProductFinderDatepicker Extra Field End


			if($row->quotation_status==1 && !SHOW_QUOTATION_PRICE)
			{
				$cart_mdata = str_replace ( "{product_price}", " ", $cart_mdata );
				$cart_mdata = str_replace ( "{product_total_price}", " ", $cart_mdata );
			} else {
				$cart_mdata = str_replace ( "{product_price}", $product_price, $cart_mdata );
				$cart_mdata = str_replace ( "{product_total_price}", $product_total_price, $cart_mdata );
			}
			$cart_mdata = str_replace ( "{product_quantity}", $product_quantity, $cart_mdata );
			$cart .= $cart_mdata;
		}

//		$cartArr = array();
//		$cartArr = $this->_carthelper->repalceOrderItems($template_middle,$rowitem);
//		$cart= $cartArr[0];

		$message = $template_start . $cart . $template_end;

		// set order paymethod name

		$search [] = "{quotation_note}";

		$replace [] = $row->quotation_note;

		$search [] = "{shopname}";

		$replace [] = SHOP_NAME;


		$search [] = "{quotation_id}";

		$replace [] = $row->quotation_id;

		$search [] = "{quotation_number}";

		$replace [] = $row->quotation_number;

		$search [] = "{quotation_date}";

		$replace [] = $redconfig->convertDateFormat ( $row->quotation_cdate );

		$search [] = "{quotation_status}";

		$replace [] = $quotationHelper->getQuotationStatusName ( $row->quotation_status );

		$billadd = '';
		if($row->user_id!=0)
		{
			$message=$this->_carthelper->replaceBillingAddress($message,$row);
		}
		else
		{
			if ($row->quotation_email != "") {

				$billadd .= JText::_ ( "EMAIL" ).' : '.$row->quotation_email.'<br />';

			}
			$message=str_replace("{billing_address_information_lbl}",JText::_('COM_REDSHOP_BILLING_ADDRESS_INFORMATION_LBL'),$message);
			if(strstr($message,"{quotation_custom_field_list}"))
			{
				$billadd .=$extra_field->list_all_field_display(16, $row->user_info_id,1,$row->quotation_email);
				$message = str_replace("{quotation_custom_field_list}", "", $message);
			}
			else
			{
				$message = $extra_field->list_all_field_display(16, $row->user_info_id,1,$row->quotation_email,$message);
			}
		}

		$search [] = "{billing_address}";

		$replace [] = $billadd;

//		echo $row->quotation_status;exit;
		$total_lbl 		= '';
		$subtotal_lbl 	='';
		$vat_lbl 	='';
		if($row->quotation_status != 1 || ($row->quotation_status == 1  && SHOW_QUOTATION_PRICE))
		{
			$total_lbl 		= JText::_('COM_REDSHOP_TOTAL_LBL');
			$subtotal_lbl 	= JText::_('COM_REDSHOP_QUOTATION_SUBTOTAL' );
			$vat_lbl 		= JText::_('COM_REDSHOP_QUOTATION_VAT' );
		}

		$message = str_replace('{total_lbl}', $total_lbl, $message );
		$message = str_replace('{quotation_subtotal_lbl}', $subtotal_lbl, $message );
		$message = str_replace('{quotation_vat_lbl}', $vat_lbl, $message );
		$message=$this->_carthelper->replaceLabel($message);

		$search [] = "{quotation_note}";

		$replace [] = $row->quotation_note;

		if ($row->quotation_status == 1  && !SHOW_QUOTATION_PRICE)
		{

			$quotation_subtotal = " ";
			$quotation_total = " ";
			$quotation_discount = " ";
			$quotation_vat = " ";

		} else {

			$quotation_subtotal = $producthelper->getProductFormattedPrice ( $row->quotation_subtotal );
			$quotation_total = $producthelper->getProductFormattedPrice ( $row->quotation_total );
			$quotation_discount = $producthelper->getProductFormattedPrice ( $row->quotation_discount );
			$quotation_vat = $producthelper->getProductFormattedPrice ( $row->quotation_tax );

		}

		$search [] = "{quotation_subtotal}";

		$replace [] = $quotation_subtotal;

		$search [] = "{quotation_total}";

		$replace [] = $quotation_total;

		$search [] = "{quotation_discount}";

		$replace [] = $quotation_discount;

		$search [] = "{quotation_vat}";

		$replace [] = $quotation_vat;

		$quotationdetailurl = JURI::root () . 'index.php?option=com_redshop&view=quotation_detail&quoid=' . $quotation_id . '&encr=' . $row->quotation_encrkey;

		$search [] = "{quotation_detail_link}";

		$replace [] = "<a href='" . $quotationdetailurl . "'>" . JText::_ ( "QUOTATION_DETAILS" ) . "</a>";

		$message = str_replace ( $search, $replace, $message );

		$message = $this->imginmail ( $message );

		$email = $row->quotation_email;

		// Set the e-mail parameters


		$from = $config->getValue ( 'mailfrom' );

		$fromname = $config->getValue ( 'fromname' );

		$body = $message;

		$subject = str_replace ( $search, $replace, $subject );

		// Send the e-mail


		if ($email != "") {

			$bcc = NULL;
			if (trim ( ADMINISTRATOR_EMAIL ) != '')
				$bcc = explode(",",trim(ADMINISTRATOR_EMAIL));

			if (! JUtility::sendMail ( $from, $fromname, $email, $subject, $body, 1, NULL, $bcc )) {
				$this->setError ( 'ERROR_SENDING_QUOTATION_MAIL' );
			}
		}

		if ($status != 0)
		{
			$quotationHelper->updateQuotationStatus ( $quotation_id, $status );
		}
		return true;
	}

	function sendNewsletterConfirmationMail($subscription_id)
	{
		if(NEWSLETTER_CONFIRMATION)
		{
			$config = &JFactory::getConfig ();
			$url = & JURI::root ();
			$option = JRequest::getVar ( 'option', '', 'request' );

			$mailinfo = $this->getMailtemplate ( 0, "newsletter_confirmation" );
			if (count ( $mailinfo ) > 0)
			{
				$message = $mailinfo [0]->mail_body;
				$subject = $mailinfo [0]->mail_subject;
			}
			else
			{
				return false;
			}
			$query = "SELECT * FROM " . $this->_table_prefix . "newsletter_subscription " .

			"WHERE subscription_id='" . $subscription_id . "' ";

			$this->_db->setQuery ( $query );

			$list = $this->_db->loadObject ();

			$link = '<a href="' . $url . 'index.php?option=' . $option . '&view=newsletter&sid=' . $subscription_id . '">' . JText::_('COM_REDSHOP_CLICK_HERE' ) . '</a>';

			$search [] = "{shopname}";

			$replace [] = SHOP_NAME;

			$search [] = "{link}";

			$replace [] = $link;

			$search [] = "{name}";

			$replace [] = $list->name;

			$email = $list->email;

			$subject = str_replace ( $search, $replace, $subject );

			$message = str_replace ( $search, $replace, $message );

			$from = $config->getValue ( 'mailfrom' );

			$fromname = $config->getValue ( 'fromname' );

			// Send the e-mail

			if ($email != "")
			{
				if (! JUtility::sendMail ( $from, $fromname, $email, $subject, $message, 1 )) {
					$this->setError ( JText::_('COM_REDSHOP_ERROR_SENDING_CONFIRMATION_MAIL' ));
				}
			}
		}
		return true;
	}

	function sendNewsletterCancellationMail($email = "")
	{

		$config = &JFactory::getConfig ();

		$mailinfo = $this->getMailtemplate ( 0, "newsletter_cancellation" );
		if (count ( $mailinfo ) > 0)
		{
			$message = $mailinfo [0]->mail_body;
			$subject = $mailinfo [0]->mail_subject;
		}
		else
		{
			return false;
		}

		$search [] = "{shopname}";

		$replace [] = SHOP_NAME;

		$subject = str_replace ( $search, $replace, $subject );

		$message = str_replace ( $search, $replace, $message );

		$from = $config->getValue ( 'mailfrom' );

		$fromname = $config->getValue ( 'fromname' );

		// Send the e-mail

		if ($email != "")
		{
			 JUtility::sendMail ( $from, $fromname, $email, $subject, $message, 1 );
		}
		return true;
	}

	function sendAskQuestionMail($ansid)
	{

		$producthelper = new producthelper ();

		$uri = & JURI::getInstance ();

		$url = $uri->root ();

		$option = JRequest::getVar ( 'option' );

		$ans = $producthelper->getQuestionAnswer ( $ansid );

		$ans = $ans [0];

		$fromname = $ans->user_name;

		$from = $ans->user_email;

		$subject = "";

		$answer = $ans->question;

		$qdetail = $producthelper->getQuestionAnswer ( $ans->parent_id );

		if (count ( $qdetail ) > 0)
		{
			$qdetail = $qdetail [0];
		}

		$question = $qdetail->question;

		$email = $qdetail->user_email;

		$product_id = $qdetail->product_id;

		$mailinfo = $this->getMailtemplate ( 0, "ask_question_mail" );

		$data_add = $ans->question;

		if (count ( $mailinfo ) > 0)
		{
			$data_add = $mailinfo [0]->mail_body;
			$subject = $mailinfo [0]->mail_subject;
		}

		$product = $producthelper->getProductById ( $product_id );

		$data_add = str_replace ( "{product_name}", $product->product_name, $data_add );

		$data_add = str_replace ( "{product_desc}", $product->product_desc, $data_add );

		$link = JRoute::_ ( $url . "index.php?option=" . $option . "&view=product&pid=" . $product_id );

		$product_url = "<a href=" . $link . ">" . $product->product_name . "</a>";

		$data_add = str_replace ( "{product_link}", $product_url, $data_add );

		$data_add = str_replace ( "{user_question}", $question, $data_add );

		$data_add = str_replace ( "{answer}", $answer, $data_add );

		$subject = str_replace ( "{user_question}", $question, $subject );

		$subject = str_replace ( "{shopname}", SHOP_NAME, $subject );

		$subject = str_replace ( "{product_name}", $product->product_name, $subject );

		if ($email != "")
		{
			if (JUtility::sendMail ( $from, $fromname, $email, $subject, $data_add, $mode = 1 ))
			{
				return true;
			}
		}
		return false;
	}

	function sendEconomicBookInvoiceMail($order_id=0,$bookinvoicepdf="")
	{
		if($order_id==0)
		{
			return false;
		}

		$redconfig = new Redconfiguration ();

		$config = &JFactory::getConfig ();
		$from = $config->getValue ( 'mailfrom' );
		$fromname = $config->getValue ( 'fromname' );

		$mailinfo = $this->getMailtemplate ( 0, "economic_inoice" );
		$data_add = "economic inoice";
		$subject = "economic_inoice";
		if (count ( $mailinfo ) > 0)
		{
			$data_add = $mailinfo [0]->mail_body;
			$subject = $mailinfo [0]->mail_subject;
		}

		$orderdetail = $this->_order_functions->getOrderDetails($order_id);
		$user_billinginfo = $this->_order_functions->getOrderBillingUserInfo($order_id);

		$search [] = "{name}";
		$search [] = "{order_number}";
		$search [] = "{order_comment}";
		$search [] = "{order_id}";
		$search [] = "{order_date}";

		if($user_billinginfo->is_company==1 && $user_billinginfo->company_name!= '')
		{
			$replace [] = $user_billinginfo->company_name;
		}
		else
		{
			$replace [] = $user_billinginfo->firstname." ".$user_billinginfo->lastname;
		}
		$replace [] = $orderdetail->order_number;
		$replace [] = $orderdetail->customer_note;
		$replace [] = $orderdetail->order_id;
		$replace [] = $redconfig->convertDateFormat ( $orderdetail->cdate );

		$data_add = str_replace ( $search, $replace, $data_add );

		$attachment [] = $bookinvoicepdf;

		if($user_billinginfo->user_email!="")
		{
			JUtility::sendMail ( $from, $fromname, $user_billinginfo->user_email, $subject, $data_add, 1, NULL, NULL, $attachment );
		}
		if (ADMINISTRATOR_EMAIL != '')
		{
			$sendto = explode(",",trim(ADMINISTRATOR_EMAIL));
			JUtility::sendMail ( $from, $fromname, $sendto, $subject, $data_add, 1, NULL, NULL, $attachment );
		}
		return true;
	}

	function getReddesignOrderItem($order_item_id)
	{
		$query = 'SELECT * ' .
				'FROM #__reddesign_order ' .
				'WHERE order_item_id="' . $order_item_id . '" ';

		$this->_db->setQuery ( $query );
		$list = $this->_db->loadObject ();
		return $list;
	}

	function sendRequestTaxExemptMail($data,$username="")
	{
		if (ADMINISTRATOR_EMAIL != '')
		{
			$mailinfo = $this->getMailtemplate ( 0, "request_tax_exempt_mail" );
			$data_add = "";
			$subject = "";
			if (count ( $mailinfo ) > 0)
			{
				$data_add = $mailinfo [0]->mail_body;
				$subject = $mailinfo [0]->mail_subject;
			}

			$config 	= &JFactory::getConfig ();
			$from 		= $config->getValue ( 'mailfrom' );
			$fromname 	= $config->getValue ( 'fromname' );

			$state_name 	= $this->_order_functions->getStateName($data->state_code);
			$country_name 	= $this->_order_functions->getCountryName($data->country_code);

			$data_add = str_replace ( "{vat_number}", $data->vat_number, $data_add );
			$data_add = str_replace ( "{username}", $username, $data_add );
			$data_add = str_replace ( "{company_name}", $data->company_name, $data_add );
			$data_add = str_replace ( "{country}", $country_name, $data_add );
			$data_add = str_replace ( "{state}", $state_name, $data_add );
			$data_add = str_replace ( "{phone}", $data->phone, $data_add );
			$data_add = str_replace ( "{zipcode}", $data->zipcode, $data_add );
			$data_add = str_replace ( "{address}", $data->address, $data_add );
			$data_add = str_replace ( "{city}", $data->city, $data_add );

			$sendto = explode(",",trim(ADMINISTRATOR_EMAIL));
			JUtility::sendMail ( $from, $fromname, $sendto, $subject, $data_add, 1);
		}
	}

}
?>